#include "font.hh"
#include <iostream> //debug

font* font::pinstance = 0; //init pointer

font* font::instance() {
	if (pinstance == 0) // is it the first call?
	{
		pinstance = new font; // create sole instance
	}
	return pinstance; // address of sole instance
}

int font::atoif(int value) {
	int retval=-1;
	if(value<'Z' && value > 64) { //if A-Z
		retval = (value-65);
	}
	if(value>='a' && value<='z') {
		retval = (value-71);
	}
	if(value>='0' && value<='9') {
		retval = (value+4);
	}
	if(value=='!') {
		retval = 62;
	}
	if(value=='?') {
		retval = 63;
	}
	return retval;
}

int font::loadfont(char *file) {
	gfx *pgfx = gfx::instance();
	pgfx->loadPCX(&fontimg,file);
	height=fontimg.height;
	//find where the chars begin and end.
	bgcol=fontimg.data[0]; //the bgcolor of the first line of the font
	int countwidth=0; //the current width being counted
	int countchar=0; //the index in font::char_space[68] that is being filled
	int countbegin=0;
	char_begin[0]=0;

	for(int i=0; i<fontimg.width; i++) {
		if(fontimg.data[i]!=bgcol) { //if this is a ref point (non-bgcolor)
			char_space[countchar]=countwidth;

			if(countchar<62) {
				char_begin[countchar+1]=countbegin;
			}

			countchar++;
			countbegin++;
			countwidth=0;
		}
		else {
			countwidth++;
			countbegin++;
		}
	}
	return 0;
}

/*******************************************************************************
** Write text.. duh =). I'm modding it to highlight text within %
*******************************************************************************/
int font::write(char *string,int x,int y) {
	int retval=0;
	int length=0; //lenght in pixel of the entire string
	int i=0;
	while(string[i]!='\0') {
		if(string[i]!='%') {
			if( string[i]!=' ') length=length + char_space[atoif(string[i])];
			else length+= char_space[0];
		}
		i++;
	}
	i=0;
	if(length<WIDTH) {
		int xpos=0;
		bool highlight=0; //to highlight or not to highlight, that is the question.
		if(x==-1) {
			xpos=(int)((WIDTH-length)/2);
		}
		else xpos=x;
		while(string[i]!='\0') {
			if(string[i]=='%') {
				if(highlight==0) {
					highlight=1;
				}
				else {
					highlight = 0;
				}
			}
			else if(string[i]<'Z' && string[i] > 64) { //if A-Z
				drawchar(string[i]-65,xpos,y,highlight);
				xpos+=char_space[string[i]-65];
			}
			else if(string[i]>='a' && string[i]<='z') {
				drawchar(string[i]-71,xpos,y,highlight);
				xpos+=char_space[string[i]-71];
			}
			else if(string[i]>='0' && string[i]<='9') {
				drawchar(string[i]+4,xpos,y,highlight);
				xpos+=char_space[string[i]+4];
			}
			else if(string[i]=='!') {
				drawchar(62,xpos,y,highlight);
				xpos+=char_space[62];
			}
			else if(string[i]=='?') {
				drawchar(63,xpos,y,highlight);
				xpos+=char_space[63];
			}
			else if(string[i]==' ') {
				xpos+=char_space[0]; //let space have the witdh of A. change if anyone wines
			}
			i++;
		}
	}
	else retval=1;
	return retval;
}

font::font() {
	//dummy
}

int font::drawchar(int index,int xpos,int ypos,bool highlight) { //make this highlight IF BOOL HIGHLIGHT!@# <<--- do this after the film
	gfx *pgfx = gfx::instance();

	for(int y=1; y<fontimg.height; y++) {
		for(int x=0; x<char_space[index]; x++) {
			if( fontimg.data[(x+char_begin[index])+(y*(fontimg.width))] != bgcol )
			{
				if(highlight) {
					pgfx->putint(xpos+x,ypos+y,HLCOL);
				}
				else pgfx->putint(xpos+x,ypos+y,fontimg.data[(x+char_begin[index])+(y*(fontimg.width))]);
			}
		}
	}
	return 0;
}