#include "define.hh"
#include "gfx.hh"
#include <iostream>

extern "C" {
    #include "tinyptc.h"
}
//singleton stuff

gfx::gfx(void) {
	//dummy
}

gfx* gfx::pinstance = 0; //init pointer

gfx* gfx::instance() {
	if (pinstance == 0) // is it the first call?
	{
		pinstance = new gfx; // create sole instance
	}
	return pinstance; // address of sole instance
}


int gfx::init() {
	if(!ptc_open("kareoke",WIDTH,HEIGHT) ) {
		return 1;
	}
	else {
		return 0;
	}
}

int gfx::putpixel(int x,int y,int r,int g,int b) {
	screen[x+WIDTH*y]=(r<<16)|(g<<8)|(b);
	return 0;
}
int gfx::putint(int x,int y, int value) {
	if(x+WIDTH*y <SIZE) {
		screen[x+WIDTH*y]=value;
		return 0;
	}
	else return 1; //request to write outside screen
}

int gfx::update() {
	ptc_update(screen);
	return 0;
}

int gfx::close() {
	ptc_close();
	return 0;
}

int gfx::clearscreen(int r,int g,int b) {
	for(int i=0; i<SIZE; i++) {
		screen[i]=(r<<16) | (g<<8) | (b);
	}
	return 0;
}


int gfx::loadPCX(MEM_Sprite *image, char* bild)
{
	FILE *file;

	unsigned char palette[768];
	unsigned char buf;
	unsigned int counter;
	PCX_Header header;

	file=fopen(bild,"r");
	if(!file==NULL) {
		fseek(file,0,SEEK_SET); //goto pos 0
		fread(&header,sizeof(PCX_Header),1,file); //grab the header

		image->width=header.xmax+1-header.xmin; //get width
		image->height=header.ymax+1-header.ymin; //get height
		image->data=new int[(image->width)*(image->height)]; //new to get mem for the image data

		//grab palette now..

		fseek(file,-768,SEEK_END); //seeks to end - 768 (beginning of palette)
		fread(palette,1,768,file); //grab palette
		fseek(file,sizeof(header),SEEK_SET); //seek to data segment

		int i=0;
		while(i < (image->height)*(image->width)) { //read the pcx and write some data...
			fread(&buf,1,1,file);
			if((buf&192)==192) {
				counter = (buf&63);
				fread(&buf,1,1,file);
				for(; counter > 0; counter--) {
					image->data[i] = (palette[buf*3]<<16) | (palette[buf*3+1]<<8) | (palette[buf*3+2]);
					i++;
				}
			}
			else {
				image->data[i] = (palette[buf*3]<<16) | (palette[buf*3+1]<<8) | (palette[buf*3+2]);
				i++;
			}
		}
		fclose(file);
		return 0;
	}
	else return 1;
}

int gfx::drawMEM(MEM_Sprite *sprite,int xpos,int ypos) {
	int curry,datay=0; //just to be optimized
	for(int y=0; y<(sprite->height); y++) {
		curry=WIDTH*y+(ypos*WIDTH);
		datay=sprite->width*y;
		//copy entire line
		memcpy(&screen[curry+xpos],sprite->data+datay,sprite->width*sizeof(int));
	}
	return 0;
}