#ifndef GFX_HH
#define GFX_HH
#include "define.hh"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//pcx header
typedef struct
{
	char signature;
	char version;
	char encoding;
	char bytes_per_pixel;
	unsigned short int xmin;
	unsigned short int ymin;
	unsigned short int xmax;
	unsigned short int ymax;
	unsigned short int vres;
	unsigned short int hres;
	char palette[48];
	char reserved;
	char color_layers;
	unsigned short int bytes_per_line;
	unsigned short int palette_type;
	char unused[58];
} PCX_Header;

//MEM_Sprite. contains raw rgb ints, width and height of pcx.
typedef struct
{
    int transpcol; //not used for now..
    int width;
    int height;
    int *data; //set this pointer to a new or malloc'ed data area
} MEM_Sprite;

class gfx {
    public:
    static gfx* instance();
    int init(); //set vid mode
    int putpixel(int x,int y, int r,int g,int b);
    int putint(int x,int y, int value);
    int update();
    int close();
    int clearscreen(int r,int g,int b);
    int loadPCX(MEM_Sprite *image, char* bild);
    int drawMEM(MEM_Sprite *image,int xpos,int ypos);
    protected:
        gfx();
        gfx(const gfx&);
        gfx& operator= (const gfx&);
    private:
    static gfx* pinstance; //pointer to the instance
    int screen[SIZE];
};

#endif //end GFX_HH